.include "../inc/x16.inc"
.include "../inc/math.inc"
.include "../inc/vera.inc"

.export draw_clear
.export draw_line
.export draw_block


draw_clear:
	stz VERA_ctrl
	vera_SET_OFFSET VRAM_bitmap
	vera_SET_STRIDE $10

	ldy #160
	ldx #240
	@loop:
	lda #$0b
	sta VERA_data0
	txa
	beq @continue
	dex
	bne @loop
	@continue:
	ldx #240
	dey
	bne @loop

	ldy #160
	ldx #240
	@loop2:
	lda #$0b
	sta VERA_data0
	txa
	beq @continue2
	dex
	bne @loop2
	@continue2:
	ldx #240
	dey
	bne @loop2
	rts


draw_line_8:
; $30,$31,$32	VERA base address.	
; $33			length of line.
; $37			color of line from 256 color palette.
	@loop:
	lda $37		; color 	
	sta VERA_data0
	dec $33
	bne @loop
	rts


draw_line:
; $30,$31,$32	VERA base address.	
; $33,$34		length of line.
; $37			color of line from 256 color palette.
	@loop:
	lda $37		; color 	
	sta VERA_data0
	sec
	lda $33
	sbc #1
	sta $33
	bne @loop
	ora $34
	beq @return
	dec $34
	bra @loop
	@return:
	rts


draw_block:
; $30,$31,$32	VERA base address.	
; $40			width of block.
; $42			height of block.
; $37			color of block from 256 color palette.
	@loop:
	dec $40
	beq @return
	lda $40
	sta $33
	vera_SET_STRIDE $10
	jsr draw_line_8
	dec $42
	beq @return
	lda $42
	sta $33
	vera_SET_STRIDE $e0
	jsr draw_line_8
	lda $40
	sta $33
	vera_SET_STRIDE $18
	jsr draw_line_8
	lda $42
	sta $33
	vera_SET_STRIDE $e8
	jsr draw_line_8
	jmp @loop

	@return:
	rts
