.include "../inc/x16.inc"

IRQVec				= $0314

; Globals
default_irq_vector: .addr 0
sim_running: .byte 0

.export sim_running

.export int_init

int_init:
	; Backup default RAM IRQ vector
	lda IRQVec
	sta default_irq_vector
	lda IRQVec+1
	sta default_irq_vector+1

	; overwrite RAM IRQ vector with custom handler address.
	sei ; Disable IRQ while vector is changing.
	lda #<custom_irq_handler
	sta IRQVec
	lda #>custom_irq_handler
	sta IRQVec+1
	lda #VSYNC_BIT ; Make VERA only generate VSYNC IRQs.
	sta VERA_ien
	cli	; enable IRQ now that vector is properly set.
	rts


custom_irq_handler:
	lda VERA_isr
	and #VSYNC_BIT
	beq @break ; Non VSYNC IRQ, no tick update.

	lda sim_running
	inc
	sta sim_running

	@break:
	; Continue to default IRQ handler.
	jmp (default_irq_vector)
	; rti will happen after jump
