.include "../inc/x16.inc"
.include "../inc/int.inc"
.include "../inc/input.inc"
.include "../inc/math.inc"
.include "../inc/vera.inc"
.include "../inc/ctl.inc"
.include "../inc/draw.inc"
.include "../inc/print.inc"
.include "../inc/palette.inc"
.include "../inc/sprite.inc"
.include "../inc/strip.inc"
.include "../inc/file.inc"

.org $080D
.segment "STARTUP"
.segment "INIT"
.segment "ONCE"
.segment "CODE"


.export main_start


jmp main_start

file_str_title: .byte $13,$10,$12,$09,$14,$05,$20,$05,$04,$09,$14,$0f,$12,0
old_tick: .byte 0


main_start:
	lda #1
	ldx #40
	ldy #30
	jsr mouse_config
	jsr int_init
	jsr vera_init_bmp
	jsr vera_init_print
	jsr ctl_init
	jsr file_init
	jsr sprite_init
	jsr palette_init
	jsr strip_init

	vera_SET_TEXT_ADDR_XY #13, #0
	print_STRING file_str_title, #$bf

	lda sim_running
	sta old_tick


	@main_loop:
	lda old_tick
	cmp sim_running
	beq @main_loop	; Wait for frame start interrupt to hit. 

	; VERA updates at top of loop to be in vertical blank.


	ldx #ZPW_MOUSE_X
	jsr mouse_get
	sta ZPB_MOUSE_BTNS

	lda sim_running
	and #$3f
	cmp #31
	bne @skip_cursor_on
	jsr file_set_cursor_on
	@skip_cursor_on:

	lda sim_running
	and #$3f
	cmp #63
	bne @skip_cursor_off
	jsr file_set_cursor_off
	@skip_cursor_off:

	jsr ctl_keyboard
	jsr ctl_process
	jsr sprite_add_pips

	; Perhaps put this at the end?
	lda sim_running
	sta old_tick

	bra @main_loop
	rts
