.include "../inc/x16.inc"
.include "../inc/math.inc"
.include "../inc/vera.inc"

.export HEX

.export print_char
.export print_next_char
.export print_hex
.export print_decimal

HEX: .byte $30,$31,$32,$33,$34,$35,$36,$37,$38,$39,$01,$02,$03,$04,$05,$06 


print_char:
; $30,$31,$32	offset
; $34			pos x
; $35			pos y
; $3a			char
; $3b			color
; Needs an offset. (y * 256) + x. Range is X: 0 to 39  Y: 0 to 29
; Needs a char to print.
; Needs a text and background color (So it can overwrite the prev char.) 
; char goes to offset+0, color goes to offset+1

	lda $34
	sta $3c
	clc
	asl
	sta $30
	lda $35
	sta $31
	stz $32
	math_chain_add VRAM_layer1_base
	stz VERA_ctrl
	lda $30+2
	ora #$10 ; Stride = 1.
	sta VERA_addr_bank
	lda $30+1
	sta VERA_addr_high
	lda $30
	sta VERA_addr_low

	lda $3a
	sta VERA_data0

	lda $3b
	sta VERA_data0
	rts


print_next_char:
; $30,$31,$32	offset
; $34			pos x
; $35			pos y
; $3a			char
; $3b			color
; Needs an offset. (y * 256) + x. Range is X: 0 to 39 Y: 0 to 29
; Needs a char to print.
; Needs a text and background color (So it can overwrite the prev char.) 
; char goes to offset+0, color goes to offset+1
	inc $3c
	lda $3c
	clc
	asl
	sta $30
	lda $35
	sta $31
	stz $32
	math_chain_add VRAM_layer1_base
	stz VERA_ctrl
	lda $30+2
	ora #$10 ; Stride = 1.
	sta VERA_addr_bank
	lda $30+1
	sta VERA_addr_high
	lda $30
	sta VERA_addr_low

	lda $3a
	sta VERA_data0

	lda $3b
	sta VERA_data0
	rts


print_hex_char:
	cmp #$a
	bpl @letter
	ora #$30
	bra @print
	@letter:
	clc
	adc #$37
	@print:
	jsr CHROUT
	rts


print_hex:
	pha
	lsr
	lsr
	lsr
	lsr
	jsr print_hex_char
	pla
	and #$0f
	jsr print_hex_char
	rts


print_decimal:
	sta @num
	lsr
	lsr
	lsr
	lsr
	ora #CHAR_0
	sta VERA_data0
	lda @num
	and #$0f
	ora #CHAR_0
	sta VERA_data0
	rts
@num: .byte 0
