.include "../inc/x16.inc"
.include "../inc/draw.inc"

;.export vera_set_vram_addr0
;.export vera_set_vram_addr1
;.export vera_add_offset_addr0
;.export vera_add_offset_addr1
;.export vera_set_sprite_data_addr0
;.export vera_set_sprite_data_addr1
;.export vera_set_palette_addr0
;.export vera_set_palette_addr1
.export vera_init_bmp
.export vera_init_print
.export vera_set_text_addr_xy


;vera_set_vram_addr0:
;	lda ZP24_VERA_ADDR0
;	sta VERA_addr_low
;	lda ZP24_VERA_ADDR0+1
;	sta VERA_addr_high
;	lda ZP24_VERA_ADDR0+2
;	sta VERA_addr_bank
;	rts


;vera_set_vram_addr1:
;	lda ZP24_VERA_ADDR1
;	sta VERA_addr_low
;	lda ZP24_VERA_ADDR1+1
;	sta VERA_addr_high
;	lda ZP24_VERA_ADDR1+2
;	sta VERA_addr_bank
;	rts


; Add ZP register 24_0 into vera addr 0.
;vera_add_offset_addr0:
;	clc
;	lda ZP24_VERA_ADDR0
;	adc ZP24_R0
;	sta ZP24_VERA_ADDR0
;	lda ZP24_VERA_ADDR0+1
;	adc ZP24_R0+1
;	sta	ZP24_VERA_ADDR0+1
;	lda ZP24_VERA_ADDR0+2
;	adc ZP24_R0+2
;	sta	ZP24_VERA_ADDR0+2
;	rts


; Add ZP register 24_0 into vera addr 1.
;vera_add_offset_addr1:
;	clc
;	lda ZP24_VERA_ADDR1
;	adc ZP24_R0
;	sta ZP24_VERA_ADDR1
;	lda ZP24_VERA_ADDR1+1
;	adc ZP24_R0+1
;	sta	ZP24_VERA_ADDR1+1
;	lda ZP24_VERA_ADDR1+2
;	adc ZP24_R0+2
;	sta	ZP24_VERA_ADDR1+2
;	rts


;vera_set_bitmap_addr0:
;	lda #00		; Use Address 0 (VERA_data0 for data i/o.)
;	sta VERA_ctrl
;	lda #<VRAM_bitmap
;	sta ZP24_VERA_ADDR0
;	lda #>VRAM_bitmap
;	sta ZP24_VERA_ADDR0+1
;	lda #^VRAM_bitmap
;	sta ZP24_VERA_ADDR0+2
;	rts


;vera_set_bitmap_addr1:
;	lda #01		; Use Address 1 (VERA_data0 for data i/o.)
;	sta VERA_ctrl
;	lda #<VRAM_bitmap
;	sta ZP24_VERA_ADDR1
;	lda #>VRAM_bitmap
;	sta ZP24_VERA_ADDR1+1
;	lda #^VRAM_bitmap
;	sta ZP24_VERA_ADDR1+2
;	rts


;vera_set_sprite_data_addr0:
;	lda #00		; Use Address 0 (VERA_data0 for data i/o.)
;	sta VERA_ctrl
;	lda #<VRAM_sprite_data
;	sta ZP24_VERA_ADDR0
;	lda #>VRAM_sprite_data
;	sta ZP24_VERA_ADDR0+1
;	lda #^VRAM_sprite_data
;	sta ZP24_VERA_ADDR0+2
;	rts


;vera_set_sprite_data_addr1:
;	lda #01		; Use Address 1 (VERA_data0 for data i/o.)
;	sta VERA_ctrl
;	lda #<VRAM_sprite_data
;	sta ZP24_VERA_ADDR1
;	lda #>VRAM_sprite_data
;	sta ZP24_VERA_ADDR1+1
;	lda #^VRAM_sprite_data
;	sta ZP24_VERA_ADDR1+2
;	rts


;vera_set_palette_addr0:
;	lda #00		; Use Address 0 (VERA_data0 for data i/o.)
;	sta VERA_ctrl
;	lda #<VRAM_palette
;	sta ZP24_VERA_ADDR0
;	lda #>VRAM_palette
;	sta ZP24_VERA_ADDR0+1
;	lda #^VRAM_palette
;	sta ZP24_VERA_ADDR0+2
;	rts


;vera_set_palette_addr1:
;	lda #01		; Use Address 1 (VERA_data0 for data i/o.)
;	sta VERA_ctrl
;	lda #<VRAM_palette
;	sta ZP24_VERA_ADDR1
;	lda #>VRAM_palette
;	sta ZP24_VERA_ADDR1+1
;	lda #^VRAM_palette
;	sta ZP24_VERA_ADDR1+2
;	rts


vera_init_bmp:
	lda #$07
	sta VERA_L0_config
	lda #(VRAM_bitmap >> 9)
	sta VERA_L0_tilebase
	stz VERA_L0_hscroll_h
	
	lda #$31
	sta VERA_dc_video

	jsr draw_clear
	rts


vera_init_print:
	stz VERA_ctrl
	lda #64
	sta VERA_dc_hscale
	sta VERA_dc_vscale
	lda #($10 | ^VRAM_layer1_base) ; Stride = 1.
	sta VERA_addr_bank
	lda #>VRAM_layer1_base
	sta VERA_addr_high
	lda #<VRAM_layer1_base
	sta VERA_addr_low
	ldy #$1f
	ldx #$3f
	@continue:
	lda #$20
	sta VERA_data0
	lda #$01
	sta VERA_data0
	dex
	bne @continue
	dey
	bne @continue
	rts


vera_set_text_addr_xy:
	clc
	lda $30
	adc #<VRAM_layer1_base
	sta $30
	lda $31
	adc #>VRAM_layer1_base
	sta $31
	lda $32
	adc #^VRAM_layer1_base
	sta $32

	stz VERA_ctrl
	lda $32
	ora #$10 ; Stride = 1.
	sta VERA_addr_bank
	lda $31
	sta VERA_addr_high
	lda $30
	sta VERA_addr_low
	rts
	