
.import vera_set_vram_addr0
.import vera_set_vram_addr1
.import vera_add_offset_addr0
.import vera_add_offset_addr1
.import vera_set_sprite_data_addr0
.import vera_set_sprite_data_addr1
.import vera_set_palette_addr0
.import vera_set_palette_addr1
.import vera_init_bmp
.import vera_init_print
.import vera_set_text_addr_xy


.macro vera_SET_VRAM_ADDR zp24, addr0_or_addr1, stride
	lda #addr0_or_addr1
	sta VERA_ctrl
	lda zp24
	sta VERA_addr_low
	lda zp24+1
	sta VERA_addr_high
	lda zp24+2
	ora #stride
	sta VERA_addr_bank
	.endmacro


.macro vera_SET_VRAM_BASE_ADDR base_addr, addr0_or_addr1
	lda #<base_addr
	sta ZP24_R0
	lda #>base_addr
	sta ZP24_R0+1
	lda #^base_addr
	sta ZP24_R0+2
	lda #addr0_or_addr1
	sta ZPB_R0
;	bne :+
;	jsr vera_set_vram_addr0
;	bra :++
;	:
;	jsr vera_set_vram_addr1
;	:
	.endmacro


.macro vera_SET_STRIDE stride
	lda VERA_addr_bank
	and #$01
	ora #stride 
	sta VERA_addr_bank
	.endmacro


.macro vera_SET_OFFSET offset
	lda #^offset
	sta VERA_addr_bank
	lda #>offset
	sta VERA_addr_high
	lda #<offset
	sta VERA_addr_low
	.endmacro


.macro vera_SET_OFFSET_24 loc
	lda loc+2
	sta VERA_addr_bank
	lda loc+1
	sta VERA_addr_high
	lda loc
	sta VERA_addr_low
	.endmacro


.macro vera_GET_OFFSET loc
	lda VERA_addr_low
	sta loc
	lda VERA_addr_high
	sta loc+1
	lda VERA_addr_bank
	sta loc+2
	.endmacro


.macro vera_SET_TEXT_ADDR_XY locx, locy
	lda locx
	clc
	asl
	sta $30
	lda locy		; This is a free "multiply by 256"
	sta $31
	stz $32
	jsr vera_set_text_addr_xy
	.endmacro


.macro vera_SET_TEXT_PIX_XY locx, locy
	lda locx
	; Divide x by 8 to convert pixels to char loc, then multiply by 2
	; to accomodate the color byte. TL;DR "Divide by 2."
	lsr		
	lsr
	sta $30
	lda locy		; This is a free "multiply by 256"
	lsr		
	lsr		
	lsr		
	sta $31
	stz $32
	jsr vera_set_text_addr_xy
	.endmacro


.macro vera_SET_TEXT_ADDR
	stz VERA_ctrl
	lda $32
	ora #$10 ; Stride = 1.
	sta VERA_addr_bank
	lda $31
	sta VERA_addr_high
	lda $30
	sta VERA_addr_low
	.endmacro


;.macro vera_SUB_OFFSET loc_24
;	sec
;	lda $30

;	lda #^offset
;	sta VERA_addr_bank
;	lda #>offset
;	sta VERA_addr_high
;	lda #<offset
;	sta VERA_addr_low
;	.endmacro


.macro vera_ADD_OFFSET_16 zp_offset
	clc
	lda $30
	adc zp_offset
	sta $30
	lda $31
	adc zp_offset+1
	sta $31
	lda $32
	adc #$0
	sta $32
	.endmacro